
# AlgTools

Author: Tuomo Valkonen <tuomov@iki.fi>

This crate/repository/package contains some general utility routines and tools for implementing
iterative algorithms and numerical computing in Rust. Former versions of the package were for Julia.
They are no longer mintained. Included are:

  * [Linear operator](crate::linops), [Euclidean space][crate::euclidean], and [norm][crate::norms] abstractions with support for matrices and vectors via `nalgebra`.
  * [Iteration abstraction](crate::iterate) for generically implementing intermittent verbosity and stopping rules in iterative algorithms.
  * The iterators can employ a [logger](crate::logger) to store the intermittent results
    (e.g. function values) in memory to later [write][crate::tabledump] into a `csv`-file.
  * Geometrical [bisection trees](crate::bisection_tree) for efficient representations of sums of functions and branch-and-bound optimisation.

<!--## Installation

???
-->
